﻿@using Microsoft.AspNetCore.Components.Authorization
@inject UsuarioAgent usuarioAgent
@inject PuestosAgent puestoAgent

<TelerikWindow Class="demo-window" Centered="true" Width="50%" @bind-Visible=@WindowVisible Modal="true">
    <WindowTitle>
        <strong>@(EsEdicion ? "Editar " : "Agregar ")Usuario</strong>
    </WindowTitle>
    <WindowActions>
        <WindowAction Name="Close" OnClick="() => EventCallback.InvokeAsync()" />
    </WindowActions>
    <WindowContent>
        <div class="px-2">
            <TelerikForm Model="@usuario.Usuario"
                         Columns="2"
                         ColumnSpacing="20px"
                         OnValidSubmit="@CreateItem">
                <FormValidation>
                    <DataAnnotationsValidator></DataAnnotationsValidator>
                </FormValidation>
                <FormItems>
                    <FormGroup LabelText="Información del usuario">
                        <FormItem Field="@nameof(UsuarioDto.Id)" LabelText="Código" Enabled="@(!EsEdicion)"></FormItem>
                        <FormItem Field="@nameof(UsuarioDto.Nombre)"></FormItem>
                        <FormItem Field="@nameof(UsuarioDto.Apellido)"></FormItem>
                        <FormItem Field="@nameof(UsuarioDto.Cedula)" LabelText="Cédula"></FormItem>
                        <FormItem Field="@nameof(UsuarioDto.FechaNacimiento)">
                            <Template>
                                <label for="mail" class="k-label k-form-label">Fecha de Nacimiento</label>
                                <TelerikDatePicker @bind-Value="usuario.Usuario.FechaNacimiento"></TelerikDatePicker>
                            </Template>
                        </FormItem>

                        <FormItem Field="@nameof(UsuarioDto.PuestoId)">
                            <Template>
                                <label for="mail" class="k-label k-form-label">Puesto</label>
                                <TelerikComboBox Data="puestos" TextField="@nameof(PuestoDto.Nombre)" ValueField="@nameof(PuestoDto.Id)" @bind-Value="usuario.Usuario.PuestoId"></TelerikComboBox>
                            </Template>
                        </FormItem>
                    </FormGroup>
                    <FormGroup LabelText="Datos de la cuenta" Columns="1">
                        <FormItem>
                            <Template>
                                <label for="mail" class="k-label k-form-label">Usuario</label>
                                <TelerikTextBox Id="mail" @bind-Value="@usuario.Username"></TelerikTextBox>
                                <TelerikValidationMessage For="@(() => usuario.Username)"></TelerikValidationMessage>
                            </Template>
                        </FormItem>
                        <FormItem>
                            <Template>
                                <label for="pass" class="k-label k-form-label">Contraseña</label>
                                <TelerikTextBox Id="pass" @bind-Value="@usuario.Password" Password="true"></TelerikTextBox>
                                <TelerikValidationMessage For="@(() => usuario.Password)"></TelerikValidationMessage>
                            </Template>
                        </FormItem>
                        <FormItem Field="@nameof(UsuarioDto.Correo)">
                            <Template>
                                <label for="mail" class="k-label k-form-label">Correo</label>
                                <TelerikTextBox Id="mail" @bind-Value="@usuario.Usuario.Correo" InputMode="email" PlaceHolder="ejemplo@domain.com"></TelerikTextBox>
                                <TelerikValidationMessage For="@(() => usuario.Usuario.Correo)"></TelerikValidationMessage>
                            </Template>
                        </FormItem>
                    </FormGroup>
                </FormItems>
                <FormButtons>
                    <div class="full-width">
                        <TelerikButton Class="k-form-submit k-button telerik-blazor k-primary" ButtonType="ButtonType.Submit">Guardar</TelerikButton>
                    </div>

                </FormButtons>
            </TelerikForm>
        </div>
    </WindowContent>
</TelerikWindow>

@code {
    [CascadingParameter]
    private Task<AuthenticationState> authenticationState { get; set; }

    [Parameter]
    public EventCallback EventCallback { get; set; }

    [Parameter]
    public bool WindowVisible { get; set; }

    [Parameter]
    public UserInfo usuario { get; set; }

    public List<PuestoDto> puestos { get; set; } = new List<PuestoDto>();

    [Parameter]
    public bool EsEdicion { get; set; }

    protected override async Task OnInitializedAsync()
    {
        puestos = await puestoAgent.Get();
    }

    private async void CreateItem()
    {

        try
        {
            if (EsEdicion)
            {
                usuario.Usuario.ModificadoPor = authenticationState.Result.User.Claims.Where(b => b.Type == "Id").FirstOrDefault().Value;
                await usuarioAgent.Modificar(usuario);
            }
            else
            {
                usuario.Usuario.Borrado = false;
                usuario.Usuario.CreadoPor = authenticationState.Result.User.Claims.Where(b => b.Type == "Id").FirstOrDefault().Value;
                usuario.Usuario.ModificadoPor = authenticationState.Result.User.Claims.Where(b => b.Type == "Id").FirstOrDefault().Value;
                await usuarioAgent.CreateUser(usuario);
            }

            StateHasChanged();
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }
        await EventCallback.InvokeAsync();
    }
}

<style type="text/css">
    .demo-window {
        z-index: 44444;
    }
</style>